diff --git a/contrib/gmm/gmm_except.h b/contrib/gmm/gmm_except.h
index 022ec28cd4..3b38aa16d3 100644
--- a/contrib/gmm/gmm_except.h
+++ b/contrib/gmm/gmm_except.h
@@ -1,32 +1,33 @@
-// -*- c++ -*- (enables emacs c++ mode)
-//===========================================================================
-//
-// Copyright (C) 2002-2008 Yves Renard
-//
-// This file is a part of GETFEM++
-//
-// Getfem++  is  free software;  you  can  redistribute  it  and/or modify it
-// under  the  terms  of the  GNU  Lesser General Public License as published
-// by  the  Free Software Foundation;  either version 2.1 of the License,  or
-// (at your option) any later version.
-// This program  is  distributed  in  the  hope  that it will be useful,  but
-// WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
-// or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
-// License for more details.
-// You  should  have received a copy of the GNU Lesser General Public License
-// along  with  this program;  if not, write to the Free Software Foundation,
-// Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
-//
-// As a special exception, you may use this file as part of a free software
-// library without restriction.  Specifically, if other files instantiate
-// templates or use macros or inline functions from this file, or you compile
-// this file and link it with other files to produce an executable, this
-// file does not by itself cause the resulting executable to be covered by
-// the GNU General Public License.  This exception does not however
-// invalidate any other reasons why the executable file might be covered by
-// the GNU General Public License.
-//
-//===========================================================================
+/* -*- c++ -*- (enables emacs c++ mode) */
+/*===========================================================================
+
+ Copyright (C) 2002-2020 Yves Renard
+
+ This file is a part of GetFEM
+
+ GetFEM  is  free software;  you  can  redistribute  it  and/or modify it
+ under  the  terms  of the  GNU  Lesser General Public License as published
+ by  the  Free Software Foundation;  either version 3 of the License,  or
+ (at your option) any later version along with the GCC Runtime Library
+ Exception either version 3.1 or (at your option) any later version.
+ This program  is  distributed  in  the  hope  that it will be useful,  but
+ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ or  FITNESS  FOR  A PARTICULAR PURPOSE.  See the GNU Lesser General Public
+ License and GCC Runtime Library Exception for more details.
+ You  should  have received a copy of the GNU Lesser General Public License
+ along  with  this program;  if not, write to the Free Software Foundation,
+ Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301, USA.
+
+ As a special exception, you  may use  this file  as it is a part of a free
+ software  library  without  restriction.  Specifically,  if   other  files
+ instantiate  templates  or  use macros or inline functions from this file,
+ or  you compile this  file  and  link  it  with other files  to produce an
+ executable, this file  does  not  by itself cause the resulting executable
+ to be covered  by the GNU Lesser General Public License.  This   exception
+ does not  however  invalidate  any  other  reasons why the executable file
+ might be covered by the GNU Lesser General Public License.
+
+===========================================================================*/
 
 /** @file gmm_except.h
     @author Yves Renard <Yves.Renard@insa-lyon.fr>
@@ -38,25 +39,39 @@
 #ifndef GMM_EXCEPT_H__
 #define GMM_EXCEPT_H__
 
+#include <sstream>
 #include "gmm_std.h"
+#include "gmm_feedback_management.h"
+
+
+//provides external implementation of gmm_exception and logging.
 
 namespace gmm {
 
 /* *********************************************************************** */
-/*	Getfem++ generic errors.                     			   */
+/*        GetFEM generic errors.                                         */
 /* *********************************************************************** */
 
+  // std logic_error with error level information
   class gmm_error: public std::logic_error {
   public:
-    gmm_error(const std::string& what_arg): std::logic_error (what_arg) {}
+    gmm_error(const std::string& what_arg, int errorLevel = 1):
+      std::logic_error (what_arg), errorLevel_(errorLevel) {}
+    int errLevel() const { return errorLevel_; }
+
+  private:
+    int errorLevel_;
   };
 
 #ifdef GETFEM_HAVE_PRETTY_FUNCTION
 #  define GMM_PRETTY_FUNCTION __PRETTY_FUNCTION__
-#else
+#elif _MSC_VER
+#  define GMM_PRETTY_FUNCTION __FUNCTION__
+#else 
 #  define GMM_PRETTY_FUNCTION ""
 #endif
 
+
   // Errors : GMM_THROW should not be used on its own.
   //          GMM_ASSERT1 : Non-maskable errors. Typically for in/ouput and
   //               when the test do not significantly reduces the performance.
@@ -65,77 +80,105 @@ namespace gmm {
   //               defined.
   //          GMM_ASSERT3 : For internal checks. Hidden by default. Active
   //               only when DEBUG_MODE is defined.
-
-#ifdef __EXCEPTIONS
+  // __EXCEPTIONS is defined by gcc, _CPPUNWIND is defined by visual c++
+#if defined(__EXCEPTIONS) || defined(_CPPUNWIND)
   inline void short_error_throw(const char *file, int line, const char *func,
-				const char *errormsg) {
-    std::stringstream msg;
-    msg << "Error in " << file << ", line " << line << " " << func
-	<< ": \n" << errormsg << ends;
-    throw gmm::gmm_error(msg.str());
+                                const char *errormsg) {
+    std::stringstream msg__;
+    msg__ << "Error in " << file << ", line " << line << " " << func
+          << ": \n" << errormsg << std::ends;
+    throw gmm::gmm_error(msg__.str());
   }
-# define GMM_THROW_(type, errormsg) {					\
-    std::stringstream msg;						\
-    msg << "Error in " << __FILE__ << ", line "				\
-	<< __LINE__ << " " << GMM_PRETTY_FUNCTION << ": \n"		\
-	<< errormsg << ends;						\
-    throw (type)(msg.str());						\
+# define GMM_THROW_(type, errormsg) {                         \
+    std::stringstream msg__;                                  \
+    msg__ << "Error in " << __FILE__ << ", line "             \
+          << __LINE__ << " " << GMM_PRETTY_FUNCTION << ": \n" \
+          << errormsg << std::ends;                           \
+    throw (type)(msg__.str());                                \
   }
+
+# define GMM_THROW_AT_LEVEL(errormsg, level)                  \
+  {                                                           \
+  std::stringstream msg;                                      \
+  msg << "Error in " << __FILE__ << ", line "                 \
+  << __LINE__ << " " << GMM_PRETTY_FUNCTION << ": \n"         \
+  << errormsg << std::ends;                                   \
+  throw gmm::gmm_error(msg.str(), level);                     \
+  }
+
 #else
+#ifndef _MSC_VER
+# define abort_no_return() ::abort()
+#else
+// apparently ::abort() on windows is not declared with __declspec(noreturn) so the compiler spits a lot of warnings when abort is used.
+# define abort_no_return() { assert("GMM ABORT"==0); throw "GMM ABORT"; }
+#endif
+
   inline void short_error_throw(const char *file, int line, const char *func,
-				const char *errormsg) {
-    std::stringstream msg;
-    msg << "Error in " << file << ", line " << line << " " << func
-	<< ": \n" << errormsg << ends;
-    ::abort();
+                                const char *errormsg) {
+    std::stringstream msg__;
+    msg__ << "Error in " << file << ", line " << line << " " << func
+          << ": \n" << errormsg << std::ends;
+    std::cerr << msg__.str() << std::endl;
+    abort_no_return();
   }
-# define GMM_THROW_(type, errormsg) {					\
-    std::stringstream msg;						\
-    msg << "Error in " << __FILE__ << ", line "				\
-	<< __LINE__ << " " << GMM_PRETTY_FUNCTION << ": \n"		\
-	<< errormsg   << ends;						\
-    ::abort();								\
+
+# define GMM_THROW_(type, errormsg) {                         \
+    std::stringstream msg__;                                  \
+    msg__ << "Error in " << __FILE__ << ", line "             \
+          << __LINE__ << " " << GMM_PRETTY_FUNCTION << ": \n" \
+          << errormsg;                                        \
+    std::cerr << msg__.str() << std::endl;                    \
+    abort_no_return();                                        \
+  }
+
+# define GMM_THROW_AT_LEVEL(errormsg, level)                  \
+  {                                                           \
+  std::stringstream msg__;                                    \
+  msg__ << "Error in " << __FILE__ << ", line "               \
+  << __LINE__ << " " << GMM_PRETTY_FUNCTION << ": \n"         \
+  << errormsg <<  " at level " << level;                      \
+  std::cerr << msg__.str()  << std::endl;                     \
+  abort_no_return();                                          \
   }
 #endif
 
-# define GMM_ASSERT1(test, errormsg)		        		\
-  { if (!(test)) GMM_THROW_(gmm::gmm_error, errormsg); }
 
-  // inline void GMM_THROW() IS_DEPRECATED;
-  inline void GMM_THROW() {}
+inline void GMM_THROW() {}
 #define GMM_THROW(a, b) { GMM_THROW_(a,b); gmm::GMM_THROW(); }
 
+# define GMM_THROW_DEFAULT(errormsg) GMM_THROW_AT_LEVEL(errormsg, 1)
+
+// This allows not to compile some assertions 
+#ifndef GMM_ASSERT_LEVEL
 #if defined(NDEBUG)
-# define GMM_ASSERT2(test, errormsg)
-# define GMM_ASSERT3(test, errormsg)
-#elif !defined(GMM_FULL_NDEBUG)
-# define GMM_ASSERT2(test, errormsg)				        \
-  { if (!(test)) gmm::short_error_throw(__FILE__, __LINE__,		\
-				   GMM_PRETTY_FUNCTION, errormsg); }
-# define GMM_ASSERT3(test, errormsg)				        \
-  { if (!(test)) gmm::short_error_throw(__FILE__, __LINE__,		\
-				   GMM_PRETTY_FUNCTION, errormsg); }
+# define GMM_ASSERT_LEVEL 1
+#elif defined(DEBUG_MODE)
+# define GMM_ASSERT_LEVEL 3
 #else
-# define GMM_ASSERT2(test, errormsg)          				\
-  { if (!(test)) gmm::short_error_throw(__FILE__, __LINE__,		\
-				   GMM_PRETTY_FUNCTION, errormsg); }
-# define GMM_ASSERT3(test, errormsg)
+# define GMM_ASSERT_LEVEL 2
+#endif
 #endif
 
-/* *********************************************************************** */
-/*	Getfem++ warnings.                         			   */
-/* *********************************************************************** */
 
-  // This allows to dynamically hide warnings
-  struct warning_level {
-    static int level(int l = -2)
-    { static int level_ = 3; return (l != -2) ? (level_ = l) : level_; }
-  };
+# define GMM_ASSERT1(test, errormsg) { if (!(test)) GMM_THROW_AT_LEVEL(errormsg, 1); }
 
-  inline void set_warning_level(int l) { warning_level::level(std::max(0,l)); }
-  inline int  get_warning_level(void)  { return warning_level::level(-2); }
+#if GMM_ASSERT_LEVEL < 2
+# define GMM_ASSERT2(test, errormsg) {}
+# define GMM_ASSERT3(test, errormsg) {}
+#elif GMM_ASSERT_LEVEL < 3
+# define GMM_ASSERT2(test, errormsg){ if (!(test)) GMM_THROW_AT_LEVEL(errormsg, 2); }
+# define GMM_ASSERT3(test, errormsg){}
+#else
+# define GMM_ASSERT2(test, errormsg){ if (!(test)) GMM_THROW_AT_LEVEL(errormsg, 2); }
+# define GMM_ASSERT3(test, errormsg){ if (!(test)) GMM_THROW_AT_LEVEL(errormsg, 3); }
+#endif
 
-  // This allow not too compile some Warnings
+/* *********************************************************************** */
+/*        GetFEM warnings.                                               */
+/* *********************************************************************** */
+
+  // This allows not to compile some Warnings
 #ifndef GMM_WARNING_LEVEL
 # define GMM_WARNING_LEVEL 4
 #endif
@@ -146,58 +189,51 @@ namespace gmm {
   //                  3 remark
   //                  4 ignored by default.
 
-#define GMM_WARNING_MSG(level_, thestr)  {			       \
-      std::stringstream msg;                                           \
-      msg << "Level " << level_ << " Warning in " << __FILE__ << ", line " \
-          << __LINE__ << ": " << thestr << ends;		       \
-       std::cerr << msg.str() << std::endl;                            \
-    }
+#define GMM_WARNING_MSG(level_, thestr)  {                                                \
+  std::stringstream msg__;                                                                \
+  msg__ << "Level " << level_ << " Warning in " << __FILE__ << ", line "                  \
+  << __LINE__ << ": " << thestr;                                                          \
+  gmm::feedback_manager::manage()->send(msg__.str(), gmm::FeedbackType::WARNING, level_); \
+}
 
 #define GMM_WARNING0(thestr) GMM_WARNING_MSG(0, thestr)
 
+
 #if GMM_WARNING_LEVEL > 0
 # define GMM_WARNING1(thestr)                                           \
-  { if (1 <= gmm::warning_level::level()) GMM_WARNING_MSG(1, thestr) }
+  { if (1 <= gmm::feedback_manager::warning_level()) GMM_WARNING_MSG(1, thestr) }
 #else
 # define GMM_WARNING1(thestr) {}
 #endif
 
 #if GMM_WARNING_LEVEL > 1
 # define GMM_WARNING2(thestr)                                           \
-  { if (2 <= gmm::warning_level::level()) GMM_WARNING_MSG(2, thestr) }
+  { if (2 <= gmm::feedback_manager::warning_level()) GMM_WARNING_MSG(2, thestr) }
 #else
-# define GMM_WARNING1(thestr) {}
+# define GMM_WARNING2(thestr) {}
 #endif
 
 #if GMM_WARNING_LEVEL > 2
 # define GMM_WARNING3(thestr)                                           \
-  { if (3 <= gmm::warning_level::level()) GMM_WARNING_MSG(3, thestr) }
+  { if (3 <= gmm::feedback_manager::warning_level()) GMM_WARNING_MSG(3, thestr) }
 #else
-# define GMM_WARNING1(thestr) {}
+# define GMM_WARNING3(thestr) {}
 #endif
 
 #if GMM_WARNING_LEVEL > 3
 # define GMM_WARNING4(thestr)                                           \
-  { if (4 <= gmm::warning_level::level()) GMM_WARNING_MSG(4, thestr) }
+  { if (4 <= gmm::feedback_manager::warning_level()) GMM_WARNING_MSG(4, thestr) }
 #else
-# define GMM_WARNING1(thestr) {}
+# define GMM_WARNING4(thestr) {}
 #endif
 
 /* *********************************************************************** */
-/*	Getfem++ traces.                         			   */
+/*        GetFEM traces.                                                 */
 /* *********************************************************************** */
 
-  // This allows to dynamically hide traces
-  struct traces_level {
-    static int level(int l = -2)
-    { static int level_ = 3; return (l != -2) ? (level_ = l) : level_; }
-  };
-
-  inline void set_traces_level(int l) { traces_level::level(std::max(0,l)); }
-
   // This allow not too compile some Warnings
 #ifndef GMM_TRACES_LEVEL
-# define GMM_TRACES_LEVEL 3
+# define GMM_TRACES_LEVEL 4
 #endif
 
   // Traces levels : 0 always printed
@@ -207,127 +243,164 @@ namespace gmm {
   //                 4 Susceptible to occur very often (>1000).
 
 #define GMM_TRACE_MSG_MPI     // for Parallelized version
-#define GMM_TRACE_MSG(level_, thestr)  {			       \
-    GMM_TRACE_MSG_MPI {						       \
-      std::stringstream msg;                                           \
-      msg << "Trace " << level_ << " in " << __FILE__ << ", line "      \
-          << __LINE__ << ": " << thestr				       \
-          << ends;						       \
-      std::cout << msg.str() << std::endl;			       \
-    }                                                                  \
-  }
+#define GMM_TRACE_MSG(level_, thestr)  {                                        \
+  GMM_TRACE_MSG_MPI {                                                           \
+    std::stringstream msg__;                                                    \
+    msg__ << "Trace " << level_ << " in " << __FILE__ << ", line "              \
+          << __LINE__ << ": " << thestr;                                        \
+    gmm::feedback_manager::send(msg__.str(), gmm::FeedbackType::TRACE, level_); \
+  }                                                                             \
+}
+
+#define GMM_TRACE_SIMPLE_MSG(level_, thestr)  {                               \
+  GMM_TRACE_MSG_MPI {                                                         \
+  std::stringstream msg__;                                                    \
+  msg__ << "Trace " << level_ << ": " << thestr;                              \
+  gmm::feedback_manager::send(msg__.str(), gmm::FeedbackType::TRACE, level_); \
+  }                                                                           \
+}
 
 #define GMM_TRACE0(thestr) GMM_TRACE_MSG(0, thestr)
+#define GMM_SIMPLE_TRACE0(thestr) GMM_TRACE_MSG_SIMPLE(0, thestr)
 
 #if GMM_TRACES_LEVEL > 0
-# define GMM_TRACE1(thestr)						\
-  { if (1 <= gmm::traces_level::level()) GMM_TRACE_MSG(1, thestr) }
+# define GMM_TRACE1(thestr)                                                          \
+  { if (1 <= gmm::feedback_manager::traces_level()) GMM_TRACE_MSG(1, thestr) }
+# define GMM_SIMPLE_TRACE1(thestr)                                                  \
+  { if (1 <= gmm::feedback_manager::traces_level()) GMM_TRACE_SIMPLE_MSG(1, thestr) }
 #else
 # define GMM_TRACE1(thestr) {}
+# define GMM_SIMPLE_TRACE1(thestr) {}
 #endif
 
 #if GMM_TRACES_LEVEL > 1
-# define GMM_TRACE2(thestr)						\
-  { if (2 <= gmm::traces_level::level()) GMM_TRACE_MSG(2, thestr) }
+# define GMM_TRACE2(thestr)                                                           \
+  { if (2 <= gmm::feedback_manager::traces_level()) GMM_TRACE_MSG(2, thestr) }
+# define GMM_SIMPLE_TRACE2(thestr)                                                   \
+  { if (2 <= gmm::feedback_manager::traces_level()) GMM_TRACE_SIMPLE_MSG(2, thestr) }
 #else
 # define GMM_TRACE2(thestr) {}
+# define GMM_SIMPLE_TRACE2(thestr) {}
 #endif
 
 #if GMM_TRACES_LEVEL > 2
-# define GMM_TRACE3(thestr)						\
-  { if (3 <= gmm::traces_level::level()) GMM_TRACE_MSG(3, thestr) }
+# define GMM_TRACE3(thestr)                                                        \
+  { if (3 <= gmm::feedback_manager::traces_level()) GMM_TRACE_MSG(3, thestr) }
+# define GMM_SIMPLE_TRACE3(thestr)                                                \
+  { if (3 <= gmm::feedback_manager::traces_level()) GMM_TRACE_SIMPLE_MSG(3, thestr) }
 #else
 # define GMM_TRACE3(thestr) {}
+# define GMM_SIMPLE_TRACE3(thestr) {}
 #endif
 
 #if GMM_TRACES_LEVEL > 3
-# define GMM_TRACE4(thestr)						\
-  { if (4 <= gmm::traces_level::level()) GMM_TRACE_MSG(4, thestr) }
+# define GMM_TRACE4(thestr)                                                         \
+  { if (4 <= gmm::feedback_manager::traces_level()) GMM_TRACE_MSG(4, thestr) }
+# define GMM_SIMPLE_TRACE4(thestr)                                                 \
+  { if (4 <= gmm::feedback_manager::traces_level()) GMM_TRACE_SIMPLE_MSG(4, thestr) }
 #else
 # define GMM_TRACE4(thestr) {}
+# define GMM_SIMPLE_TRACE4(thestr) {}
 #endif
 
-
-  /* ********************************************************************* */
-  /*    Definitions for compatibility with old versions.        	   */
-  /* ********************************************************************* */
-
-  using std::invalid_argument;
-
-  struct dimension_error : public std::logic_error
-  { dimension_error(const std::string& w): std::logic_error(w) {} };
-  struct file_not_found_error : public std::logic_error
-  { file_not_found_error(const std::string& w): std::logic_error (w) {} };
-  struct internal_error : public std::logic_error
-  { internal_error(const std::string& w): std::logic_error(w) {} };
-  struct failure_error : public std::logic_error
-  { failure_error(const std::string& w): std::logic_error (w) {} };
-  struct not_linear_error : public std::logic_error
-  { not_linear_error(const std::string& w): std::logic_error (w) {} };
-  struct to_be_done_error : public std::logic_error
-  { to_be_done_error(const std::string& w): std::logic_error (w) {} };
-
-#define GMM_STANDARD_CATCH_ERROR   catch(std::logic_error e)	\
-    {								\
-      cerr << "============================================\n";	\
-      cerr << "|      An error has been detected !!!      |\n";	\
-      cerr << "============================================\n";	\
-      cerr << e.what() << endl << endl;				\
-      exit(1);							\
-    }								\
-  catch(std::runtime_error e)					\
-    {								\
-      cerr << "============================================\n";	\
-      cerr << "|      An error has been detected !!!      |\n";	\
-      cerr << "============================================\n";	\
-      cerr << e.what() << endl << endl;				\
-      exit(1);							\
-    }								\
-  catch(std::bad_alloc) {					\
-    cerr << "============================================\n";	\
-    cerr << "|  A bad allocation has been detected !!!  |\n";	\
-    cerr << "============================================\n";	\
-    exit(1);							\
-  }								\
-  catch(std::bad_typeid) {					\
-    cerr << "============================================\n";	\
-    cerr << "|  A bad typeid     has been detected !!!  |\n";	\
-    cerr << "============================================\n";	\
-    exit(1);							\
-  }								\
-  catch(std::bad_exception) {					\
-    cerr << "============================================\n";	\
-    cerr << "|  A bad exception  has been detected !!!  |\n";	\
-    cerr << "============================================\n";	\
-    exit(1);							\
-  }								\
-  catch(std::bad_cast) {					\
-    cerr << "============================================\n";	\
-    cerr << "|    A bad cast  has been detected !!!     |\n";	\
-    cerr << "============================================\n";	\
-    exit(1);							\
-  }								\
-  catch(...) {							\
-    cerr << "============================================\n";	\
-    cerr << "|  An unknown error has been detected !!!  |\n";	\
-    cerr << "============================================\n";	\
-    exit(1);							\
+#define GMM_STANDARD_CATCH_ERROR                                           \
+  catch(const gmm::gmm_error &e)                                           \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "|    A GMM error has been detected !!!     |\n";         \
+    strStream << "============================================\n";         \
+    strStream << e.what() << std::endl << std::endl;                       \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, e.errLevel());   \
+    gmm::feedback_manager::terminating_action();                           \
+  }                                                                        \
+  catch(const std::logic_error &e)                                         \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "|       An error has been detected !!!     |\n";         \
+    strStream << "============================================\n";         \
+    strStream << e.what() << std::endl << std::endl;                       \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, 0);              \
+    gmm::feedback_manager::terminating_action();                           \
+  }                                                                        \
+  catch(const std::runtime_error &e)                                       \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "| A runtime error has been detected !!!    |\n";         \
+    strStream << "============================================\n";         \
+    strStream << e.what() << std::endl << std::endl;                       \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, 0);              \
+    gmm::feedback_manager::terminating_action();                           \
+  }                                                                        \
+  catch(const std::bad_alloc &)                                            \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "| A bad allocation has been detected !!!   |\n";         \
+    strStream << "============================================\n";         \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, 0);              \
+    gmm::feedback_manager::terminating_action();                           \
+  }                                                                        \
+  catch(const std::bad_typeid &)                                           \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "|  A bad typeid has been detected !!!      |\n";         \
+    strStream << "============================================\n";         \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, 0);              \
+    gmm::feedback_manager::terminating_action();                           \
+  }                                                                        \
+  catch(const std::bad_exception &)                                        \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "|  A bad exception has been detected !!!   |\n";         \
+    strStream << "============================================\n";         \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, 0);              \
+    gmm::feedback_manager::terminating_action();                           \
+  }                                                                        \
+  catch(const std::bad_cast &)                                             \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "|      A bad_cast has been detected !!!    |\n";         \
+    strStream << "============================================\n";         \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, 0);              \
+    gmm::feedback_manager::terminating_action();                           \
+  }                                                                        \
+  catch(...)                                                               \
+  {                                                                        \
+    std::stringstream strStream;                                           \
+    strStream << "============================================\n";         \
+    strStream << "|  An unknown error has been detected !!!  |\n";         \
+    strStream << "============================================\n";         \
+    gmm::feedback_manager::send(strStream.str(),                           \
+                               gmm::FeedbackType::ASSERT, 0);              \
+    gmm::feedback_manager::terminating_action();                           \
   }
   //   catch(ios_base::failure) {
-  //     cerr << "============================================\n";
-  //     cerr << "| A ios_base::failure has been detected !!!|\n";
-  //     cerr << "============================================\n";
+  //     std::cerr << "============================================\n";
+  //     std::cerr << "| A ios_base::failure has been detected !!!|\n";
+  //     std::cerr << "============================================\n";
   //     exit(1);
   //   }
 
 #if defined(__GNUC__) && (__GNUC__ > 3)
-# define GMM_SET_EXCEPTION_DEBUG				\
+# define GMM_SET_EXCEPTION_DEBUG                                \
   std::set_terminate(__gnu_cxx::__verbose_terminate_handler);
 #else
 # define GMM_SET_EXCEPTION_DEBUG
 #endif
 
-}
-
+} // namespace gmm
 
 #endif /* GMM_EXCEPT_H__ */
